"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app = require("tns-core-modules/application");
var permissions = require("nativescript-perms");
function callIntent(context, intent, pickerType) {
    return permissions.request('storage').then(function () {
        return new Promise(function (resolve, reject) {
            console.log(' callIntent ', intent, pickerType);
            var onEvent = function (e) {
                console.log(' startActivityForResult ', e.requestCode);
                if (e.requestCode === pickerType) {
                    resolve(e);
                    app.android.off(app.AndroidApplication.activityResultEvent, onEvent);
                }
            };
            app.android.once(app.AndroidApplication.activityResultEvent, onEvent);
            context.startActivityForResult(intent, pickerType);
        });
    });
}
function openFilePicker(params) {
    console.log('openFilePicker', params);
    var extensions;
    if (params.extensions.length > 0) {
        extensions = Array.create(java.lang.String, params.extensions.length);
        for (var i = 0; i < params.extensions.length; i++) {
            extensions[i] = params.extensions[i];
        }
    }
    var context = app.android.foregroundActivity || app.android.startActivity;
    var FILE_CODE = 1231;
    var intent = new android.content.Intent(android.content.Intent.ACTION_GET_CONTENT);
    var types = (params.extensions
        && params.extensions
            .map(function (s) { return android.webkit.MimeTypeMap.getSingleton().getMimeTypeFromExtension(s); })
            .filter(function (s) { return !!s; })
            .join(' | ')) || '*/*';
    console.log('types', types);
    intent.setType(types);
    intent.addCategory(android.content.Intent.CATEGORY_OPENABLE);
    intent.setAction(android.content.Intent.ACTION_OPEN_DOCUMENT);
    intent.putExtra(android.content.Intent.EXTRA_ALLOW_MULTIPLE, !!params.multipleSelection);
    return callIntent(context, intent, FILE_CODE).then(function (result) {
        console.log('on callIntent result', result.resultCode, android.app.Activity.RESULT_OK);
        if (result.resultCode === android.app.Activity.RESULT_OK) {
            if (result.intent != null) {
                var uri = result.intent.getData();
                console.log('on picker result', uri, com.nativescript.documentpicker.FilePath.getPath(context, uri));
                return {
                    files: [com.nativescript.documentpicker.FilePath.getPath(context, uri)],
                    android: uri
                };
            }
            return {
                files: []
            };
        }
        else {
            return {
                files: []
            };
        }
    });
}
exports.openFilePicker = openFilePicker;
//# sourceMappingURL=filepicker.android.js.map